-------------------------------------------------------
-- bcd counter (up/down)
-- 2006/7/18
-------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity bcdcounterud is
	port(
		clk		:in std_logic;
		clear	:in std_logic;
		carryin	:in std_logic;
		updown	:in std_logic;
		qa		:out std_logic;
		qb		:out std_logic;
		qc		:out std_logic;
		qd		:out std_logic;
		carryout:out std_logic
	);
end bcdcounterud;

architecture rtl of bcdcounterud is
	signal incounter	:std_logic_vector(3 downto 0);

begin
	process(clk,clear,carryin,updown)
	begin
	if (updown ='0')then
		if(clear ='1') then
			incounter <= "0000";
			elsif(clk' event and clk='1' and carryin ='1') then
				if(incounter = "1001") then
					incounter <= "0000";
				else
					incounter <= incounter + 1;
				end if;
		end if;
	end if;
	
	if (updown ='1')then
		if(clear ='1') then
			incounter <= "0000";
			elsif(clk' event and clk='1' and carryin ='1') then
				if(incounter = "0000") then
					incounter <= "1001";
				else
					incounter <= incounter - 1;
				end if;
		end if;
	end if;
	end process;
	
	process(incounter,carryin,updown)
	begin
		if(incounter = "1001" and carryin ='1' and updown ='0' )then
			carryout <= '1';
		else
			carryout <= '0';
		end if;
		
		if(incounter = "0000" and carryin ='1' and updown ='1' )then
			carryout <= '1';
		else
			carryout <= '0';
		end if;
	end process;
	
	qa <= incounter(0);
	qb <= incounter(1);
	qc <= incounter(2);
	qd <= incounter(3);

end rtl;